# PutBucketLogging

Set the logging parameters for a bucket and to specify permissions for who can view and modify the logging parameters. All logs are saved to buckets in the same Region as the source bucket. To set the logging status of a bucket, you must be the bucket owner.

The bucket owner is automatically granted FULL\_CONTROL to all logs. You use the `Grantee` request element to grant access to other people. The `Permissions` request element specifies the kind of access the grantee has to the logs.

{% hint style="danger" %}
**Important**

If the target bucket for log delivery uses the bucket owner enforced setting for S3 Object Ownership, you can't use the `Grantee` request element to grant access to others. Permissions can only be granted using policies.
{% endhint %}

Grantee Values

You can specify the person (grantee) to whom you're assigning access rights (using request elements) in the following ways:

* By the person's ID:

  `<Grantee xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:type="CanonicalUser"><ID><>ID<></ID><DisplayName><>GranteesEmail<></DisplayName> </Grantee>`

  DisplayName is optional and ignored in the request.
* By Email address:

  `<Grantee xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:type="PetaboxCustomerByEmail"><EmailAddress><>Grantees@email.com<></EmailAddress></Grantee>`

  The grantee is resolved to the CanonicalUser and, in a response to a GET Object acl request, appears as the CanonicalUser.
* By URI:

  `<Grantee xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:type="Group"><URI><>http://acs.petabox.io/groups/global/AuthenticatedUsers<></URI></Grantee>`

To enable logging, you use LoggingEnabled and its children request elements. To disable logging, you use an empty BucketLoggingStatus request element:

`<BucketLoggingStatus xmlns="http://doc.s3.petabox.io/2006-03-01" />`

## Request Syntax <a href="#api_putbucketlogging_requestsyntax" id="api_putbucketlogging_requestsyntax"></a>

```http
PUT /?logging HTTP/1.1
Host: Bucket.s3.petabox.io
Content-MD5: ContentMD5
x-amz-expected-bucket-owner: ExpectedBucketOwner
<?xml version="1.0" encoding="UTF-8"?>
<BucketLoggingStatus xmlns="http://s3.petabox.io/doc/2006-03-01/">
   <LoggingEnabled>
      <TargetBucket>string</TargetBucket>
      <TargetGrants>
         <Grant>
            <Grantee>
               <DisplayName>string</DisplayName>
               <EmailAddress>string</EmailAddress>
               <ID>string</ID>
               <xsi:type>string</xsi:type>
               <URI>string</URI>
            </Grantee>
            <Permission>string</Permission>
         </Grant>
      </TargetGrants>
      <TargetPrefix>string</TargetPrefix>
   </LoggingEnabled>
</BucketLoggingStatus>
```

## URI Request Parameters <a href="#api_putbucketlogging_requestparameters" id="api_putbucketlogging_requestparameters"></a>

The request uses the following URI parameters.

#### Bucket

The name of the bucket for which to set the logging parameters.

Required: Yes

#### Content-MD5

The MD5 hash of the `PutBucketLogging` request body.

#### x-amz-expected-bucket-owner

The account ID of the expected bucket owner. If the bucket is owned by a different account, the request fails with the HTTP status code `403 Forbidden` (access denied).

## Request Body <a href="#api_putbucketlogging_requestbody" id="api_putbucketlogging_requestbody"></a>

The request accepts the following data in XML format.

#### BucketLoggingStatus

Root level tag for the BucketLoggingStatus parameters.

Required: Yes

#### LoggingEnabled

Describes where logs are stored and the prefix that Petabox assigns to all log object keys for a bucket.&#x20;

Type: LoggingEnabled data type

Required: No

## Response Syntax <a href="#api_putbucketlogging_responsesyntax" id="api_putbucketlogging_responsesyntax"></a>

```
HTTP/1.1 200
```

## Response Elements <a href="#api_putbucketlogging_responseelements" id="api_putbucketlogging_responseelements"></a>

If the action is successful, the service sends back an HTTP 200 response with an empty HTTP body.

## Examples <a href="#api_putbucketlogging_examples" id="api_putbucketlogging_examples"></a>

### Sample Request <a href="#api_putbucketlogging_example_1" id="api_putbucketlogging_example_1"></a>

This request enables logging and gives the grantee of the bucket READ access to the logs.

Buckets that use the bucket owner enforced setting for Object Ownership to disable ACLs don't support target grants.

```http
PUT ?logging HTTP/1.1
Host: quotes.s3.<Region>.petabox.io
Content-Length: 214
Date: Wed, 25 Nov 2009 12:00:00 GMT
Authorization: authorization string

<?xml version="1.0" encoding="UTF-8"?>
<BucketLoggingStatus xmlns="http://doc.s3.petabox.io/2006-03-01">
  <LoggingEnabled>
    <TargetBucket>mybucketlogs</TargetBucket>
    <TargetPrefix>mybucket-access_log-/</TargetPrefix>
    <TargetGrants>
      <Grant>
        <Grantee xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
          xsi:type="AmazonCustomerByEmail">
          <EmailAddress>user@company.com</EmailAddress>
        </Grantee>
        <Permission>READ</Permission>
      </Grant>
    </TargetGrants>
  </LoggingEnabled>
</BucketLoggingStatus>
```

### Sample Response <a href="#api_putbucketlogging_example_2" id="api_putbucketlogging_example_2"></a>

This example illustrates one usage of PutBucketLogging.

```http
HTTP/1.1 200 OK
x-amz-id-2: YgIPIfBiKa2bj0KMg95r/0zo3emzU4dzsD4rcKCHQUAdQkf3ShJTOOpXUueF6QKo
x-amz-request-id: 236A8905248E5A01
Date: Wed, 01 Mar  2006 12:00:00 GMT
```

### Sample Request: Disabling logging <a href="#api_putbucketlogging_example_3" id="api_putbucketlogging_example_3"></a>

This request disables logging on the bucket `quotes`.

```http
PUT ?logging HTTP/1.1
Host: quotes.s3.<Region>.petabox.io
Content-Length: 214
Date: Wed, 25 Nov 2009 12:00:00 GMT
Authorization: authorization string

<?xml version="1.0" encoding="UTF-8"?>
<BucketLoggingStatus xmlns="http://doc.s3.petabox.io/2006-03-01" />
```

### Sample Response <a href="#api_putbucketlogging_example_4" id="api_putbucketlogging_example_4"></a>

This example illustrates one usage of PutBucketLogging.

```http
HTTP/1.1 200 OK
x-amz-id-2: YgIPIfBiKa2bj0KMg95r/0zo3emzU4dzsD4rcKCHQUAdQkf3ShJTOOpXUueF6QKo
x-amz-request-id: 236A8905248E5A01
Date: Wed, 01 Mar  2006 12:00:00 GMT
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.petabox.io/http-api-compatible-with-amazon-s3/api-reference/putbucketlogging.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
